VLF = {}
function VLF.init(MAIN)
	if not MAIN then 
		MAIN = "main.vlf"
	end

VLF.Content = VLF.GetDataFromfile(MAIN,"psp_vlf")	
VLF.Font = pge.font.loadmemory(VLF.Content[1],15,PGE_VRAM)
VLF.Font_small = pge.font.loadmemory(VLF.Content[1],14.5,PGE_VRAM)
VLF.Font_huge= pge.font.loadmemory(VLF.Content[1],28,PGE_VRAM)

--defining Colors 
VLF.Text_Color = pge.gfx.createcolor(255,255,255,220)
VLF.Shadow_Color =  pge.gfx.createcolor(0,0,0,6)
VLF.white =  pge.gfx.createcolor(163,163,163,120)
VLF.yellow =  pge.gfx.createcolor(118,186,34,120)
VLF.green =  pge.gfx.createcolor(119,177,12,120)
VLF.pink =  pge.gfx.createcolor(255,182,242,120)
VLF.green2 =  pge.gfx.createcolor(2,141,2,120)
VLF.purple =  pge.gfx.createcolor(169,75,189,120)
VLF.cyan =  pge.gfx.createcolor(0,171,153,120)
 VLF.blue =  pge.gfx.createcolor(2,157,213,120)
VLF.purple2 =  pge.gfx.createcolor(155,65,172,120)
VLF.yellow2 =  pge.gfx.createcolor(214,144,9,120)
VLF.brown =  pge.gfx.createcolor(114,64,31,120)
VLF.red =  pge.gfx.createcolor(202,22,8,120)
VLF.Colors = {
VLF.white,
VLF.yellow,
VLF.green,
VLF.pink,
VLF.green2,
VLF.purple,
VLF.cyan,
VLF.blue,
VLF.purple2,
VLF.yellow2,
VLF.brown,
VLF.red
}


VLF_CENTER = 0x100
VLF_RIGHT = 0x110
VLF_ARROW_UP = 0x105
VLF_ARROW_DOWN = 0x107
VLF_ARROW_UP_DOWN = 0x109

VLF_USE_BUTTONS = 0x111
VLF_AUTO_COLOR = 0x120
OLD_BG = 0
top_y = -24
VLF_XMB_LAG = 2
VLF_MAIN_ALPHA = 1
VLF_FOCUS_SPEED = 40
VLF_FOCUS_ANIMATION_FRAMES = 1
VLF_FOCUS_ALPHA = 0
VLF_FOCUS_ALHPA_DECREASE = false
SET_HIGHLIGHT_BUTTON = 1

VLF_DISABLE_FOCUS_ANIMATION = false
VLF_FADE_SPEED_SLOW = 0.1
VLF_FADE_SPEED_STANDARD = 0.2
VLF_FADE_SPEED_FAST = 0.3
VLF_FADE_SPEED_VERY_FAST = 0.4 
VLF_FADE_SPEED_SUPER_FAST = 0.5

TOP = {} --containing standart preloaded icons
TOP.APP = pge.texture.loadmemory(VLF.Content[2])--PSP Icon
TOP.UPD = pge.texture.loadmemory(VLF.Content[3])--Update Icon 
TOP.EGG = pge.texture.loadmemory(VLF.Content[4])--EGG Icon (Used for Betas, Demos...)
TOP.INF  = pge.texture.loadmemory(VLF.Content[5])--? Icon

--symbols
VLF_CROSS = "854ff4785"
VLF_CIRCLE = "6436ff364"
VLF_SQUARE = "62ff34564"
VLF_TRIANGLE = "7234ff574"
VLF_SELECT = "4ff832547"
VLF_START = "547575ff6"
VLF_RTRIGGER = "457ff3978"
VLF_LTRIGGER = "873ff9486"
VLF.Buttons = {{VLF_CROSS,3},{VLF_CIRCLE,3},{VLF_SQUARE,3},{VLF_TRIANGLE,3},{VLF_SELECT,7},{VLF_START,7},{VLF_RTRIGGER,3},{VLF_LTRIGGER,3}}
choice = pge.texture.loadmemory(VLF.Content[6])

SND_CURSOR = pge.wav.loadmemory(VLF.Content[7])

wave_a = pge.texture.loadmemory(VLF.Content[8])

wave_b_1 = pge.texture.loadmemory(VLF.Content[9])

wave_b_2 = pge.texture.loadmemory(VLF.Content[10])

inst_line = pge.texture.loadmemory(VLF.Content[11])
inst_line_back = pge.texture.loadmemory(VLF.Content[12])

scr_line_back = pge.texture.loadmemory(VLF.Content[13])
scr_line = pge.texture.loadmemory(VLF.Content[14])

batterie_img = pge.texture.loadmemory(VLF.Content[15])
batterie_shadow_img = pge.texture.loadmemory(VLF.Content[16])
batterie_line_img = pge.texture.loadmemory(VLF.Content[17])

textbox = pge.texture.loadmemory(VLF.Content[18])

vlf_text_arrow = pge.texture.loadmemory(VLF.Content[19])

--psp buttons 
VLF_cross = pge.texture.loadmemory(VLF.Content[22])
VLF_circle = pge.texture.loadmemory(VLF.Content[20])
VLF_square = pge.texture.loadmemory(VLF.Content[24])
VLF_triangle = pge.texture.loadmemory(VLF.Content[26])
VLF_select = pge.texture.loadmemory(VLF.Content[32])
VLF_start = pge.texture.loadmemory(VLF.Content[34])
VLF_rtrigger =  pge.texture.loadmemory(VLF.Content[30])
VLF_ltrigger =  pge.texture.loadmemory(VLF.Content[28])
--psp button shadows 
VLF_cross_shad = pge.texture.loadmemory(VLF.Content[23])
VLF_circle_shad = pge.texture.loadmemory(VLF.Content[21])
VLF_square_shad = pge.texture.loadmemory(VLF.Content[25])
VLF_triangle_shad = pge.texture.loadmemory(VLF.Content[27])
VLF_select_shad = pge.texture.loadmemory(VLF.Content[33])
VLF_start_shad = pge.texture.loadmemory(VLF.Content[35])
VLF_rtrigger_shad =  pge.texture.loadmemory(VLF.Content[31])
VLF_ltrigger_shad =  pge.texture.loadmemory(VLF.Content[29])

for i = 1, #VLF.Content do 
VLF.Content[i] = nil 
end 
VLF.Content = nil
end 


function VLF.SetImageColor(image,color)
	r = pge.gfx.red(color)
	g = pge.gfx.green(color)
	b = pge.gfx.blue(color)
		width = (image:width()-1)
		height = (image:height()-1)
		pge.texture.unswizzle(image)
for x = 0, width do 
	for y = 0,height do 
		tex_Color = pge.texture.pixel(image, x, y)
		alpha = pge.gfx.alpha(tex_Color) 
		pge.texture.pixel(image, x, y,pge.gfx.createcolor(r,g,b,alpha))
	end 
end 
pge.texture.swizzle(image)
return image
end 

function VLF.DrawSymbol(x,y,symbol,draw_without_shadow,not_fade)
if symbol == VLF_CROSS then 
	symb = VLF_cross
	if not draw_without_shadow then 
	shad_symb = VLF_cross_shad
	end 
elseif symbol == VLF_CIRCLE then
	symb = VLF_circle
	if not draw_without_shadow then 
	shad_symb = VLF_circle_shad
	end 
elseif symbol == VLF_SQUARE then
	symb = VLF_square
	if not draw_without_shadow then 
	shad_symb = VLF_square_shad
	end 
elseif symbol == VLF_TRIANGLE then
	symb = VLF_triangle
	if not draw_without_shadow then 
	shad_symb = VLF_triangle_shad
	end 
elseif symbol == VLF_SELECT then 
	symb = VLF_select
	if not draw_without_shadow then 
	shad_symb = VLF_select_shad
	end 
elseif symbol == VLF_START then 
	symb = VLF_start
	if not draw_without_shadow then 
	shad_symb = VLF_start_shad
	end 
elseif symbol == VLF_RTRIGGER then
	symb = VLF_rtrigger
	if not draw_without_shadow then 
	shad_symb = VLF_rtrigger_shad
	end 
elseif symbol == VLF_LTRIGGER then 
	symb = VLF_ltrigger
	if not draw_without_shadow then 
	shad_symb = VLF_ltrigger_shad
	end 
end 
if not_fade then 
	if not draw_without_shadow then 
	shad_symb:activate()
	shad_symb:draw(x-2,y-2)
	end 
	symb:activate()
	symb:draw(x,y)
else
	if not draw_without_shadow then 
	shad_symb:activate()
	VLF.DrawTexture(shad_symb,x-2,y-2)
	end 
	symb:activate()
	VLF.DrawTexture(symb,x,y)
end 

end 

function VLF.DrawTexture(texture,x,y,width,height,startx,starty,endx,endy,rotation,alpha)
if not width then 
	width = texture:width()
end
if not height then 
	height = texture:height()
end 
if not startx then 
	startx = 0 
end 
if not starty then 
	starty = 0 
end 
if not endx then 
	endx = texture:width()
end 
if not endy then 
	endy = texture:height()
end
if not rotation then 
	rotation = 0 
end
if not alpha then 
	alpha = 255
end 
texture:draw(x,y,width,height,startx,starty,endx,endy,rotation,alpha*VLF_MAIN_ALPHA)
end 

function VLF.DrawStatusBar(percent,text,width,x,y)
	if not width then 
		width = 326
	end 
	if not x then 
		x = 240-width/2
	end
	if not y then 
		y = 137
	end 
if percent < 0 then 
	percent = 0 
end 
if percent > 100 then 
	percent = 100 
end 
inst_line_back:activate()
VLF.DrawTexture(inst_line_back,x,y)
inst_line:activate()
VLF.DrawTexture(inst_line,x+4,y,318/100*percent,4)
VLF.DrawText(x,y-27,VLF.Font,text,2,4,VLF.Text_Color,VLF.Shadow_Color)
local percent_string = math.floor(percent+0.5)..string.char(35)
VLF.DrawText((x+width/2)-VLF.Font:measure(percent_string)/2,y+19,VLF.Font,percent_string,2,4,VLF.Text_Color,VLF.Shadow_Color)
end 

function VLF.GetDataFromfile(comp_file,key,keep_key,POS)	
local	file = pge.file.open(comp_file,PGE_FILE_RDONLY)
local combined_file = pge.file.read(file,pge.file.size(file))
pge.file.close(file)

function return_ser_res(string,search_var)
found = {}
	while true do 		
	if not start_search then 
		start_search = 1	
	else
		start_search = found[#found]+2
	end
	found_pos = string.find(string,search_var,start_search)
		if found_pos ~= nil then 
		found[#found+1] = found_pos-1
		else
		break
		end		
	end 
start_search = nil
return found
end

local combined_file_tb = return_ser_res(combined_file,key)
local splitted = {}
 
for parts = 1, #combined_file_tb  do 
if parts == #combined_file_tb  then 
sub_to = #combined_file-1
else
sub_to = combined_file_tb[parts+1]
end 
sub_from = combined_file_tb[parts]
splitted[parts] =   string.sub(combined_file,sub_from,sub_to)
end
combined_file_tb = nil
combined_file = nil
found = nil
 
if POS then 
	if not keep_key then
		if POS == 1 then 
		addkey = 1 
		else
		addkey = 2 
		end 
		file = string.sub(splitted[POS],#key+addkey,#splitted[POS])
	else
	file = splitted[POS]
	end 
else
if not keep_key then  
	for i = 1,#splitted do 
		if i == 1 then 
		addkey = 1 
		else
		addkey = 2 
		end 
	splitted[i] = string.sub(splitted[i],#key+addkey,#splitted[i])
	end 
end 
file = splitted
end 
return file
end 

function VLF.CompDataTofile(file,table,key)
local ret_string = ""
	for comb = 1, #table do 
		if not pge.file.exists(table[comb]) then 
		error("the required file: "..table[comb].."  cannot be found")
		end
		rm_file = pge.file.open(table[comb],PGE_FILE_RDONLY)
		comb_string = pge.file.read(rm_file,pge.file.size(rm_file))
		if key then 
		comb_string = key..comb_string
		end 
		if comb == #table then 
		comb_string = comb_string.." "
		end
		ret_string = ret_string..comb_string		
		pge.file.close(rm_file)
	end 
local write_to = pge.file.open(file,PGE_FILE_CREATE+PGE_FILE_WRONLY)
pge.file.write(write_to,ret_string)
ret_string = nil
comb_string = nil	
pge.file.close(write_to)
end


function VLF.GetBG(BG,file,setImages)
	if not file then file = "theme.VLF" end 
	if BG ~= OLD_BG then 
		VLF_BG = nil
		if not BG then 
		BG = os.date("*t").month
		end
	VLF_BG = pge.texture.loadmemory(VLF.GetDataFromfile(file,"pspbg",false,BG))
	OLD_BG = BG
	CURRENT_BG = BG
if BG == 30 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 180
elseif BG == 29 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 28 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,25)
	VLF_WAVE_ALPHA = 170
elseif BG == 27 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,22)
	VLF_WAVE_ALPHA = 125
elseif BG == 26 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,15)
	VLF_WAVE_ALPHA = 125
elseif BG == 25 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 160
elseif BG == 24 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 210
elseif BG == 23 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 22 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 21 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 160
elseif BG == 20 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 200
elseif BG == 19 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 18 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 200
elseif BG == 17 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 225
elseif BG == 16 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 240
elseif BG == 15 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 14 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 220
elseif BG == 13 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 12 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,0,0,8)
	VLF_WAVE_ALPHA = 180
elseif BG == 11 then 
	VLF.Shadow_Color = pge.gfx.createcolor(76,48,17,8)
	VLF_WAVE_ALPHA = 180
elseif BG == 10 then 
	VLF.Shadow_Color = pge.gfx.createcolor(164,162,28,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 9 then 
	VLF.Shadow_Color = pge.gfx.createcolor(127,37,140,8)
	VLF_WAVE_ALPHA = 210
elseif BG == 8 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,5,130,15)
	VLF_WAVE_ALPHA = 200
elseif BG == 7 then 
	VLF.Shadow_Color = pge.gfx.createcolor(28,176,164,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 6 then 
	VLF.Shadow_Color = pge.gfx.createcolor(0,23,156,8)
	VLF_WAVE_ALPHA = 220
elseif BG == 5 then 
	VLF.Shadow_Color = pge.gfx.createcolor(28,176,164,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 4 then 
	VLF.Shadow_Color = pge.gfx.createcolor(198,38,88,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 3 then 
	VLF.Shadow_Color = pge.gfx.createcolor(28,176,164,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 2 then 
	VLF.Shadow_Color = pge.gfx.createcolor(197,152,35,8)
	VLF_WAVE_ALPHA = 255
elseif BG == 1 then 
	VLF.Shadow_Color = pge.gfx.createcolor(144,144,144,8)
	VLF_WAVE_ALPHA = 255
else
	VLF_WAVE_ALPHA = 255 --Custom Background
end 
if setImages then
	VLF.SetImageColor(batterie_shadow_img,VLF.Shadow_Color)
end
end 
return VLF_BG
end

function VLF.DrawText(x,y,font,text,distance,radius,color,shadowcolor,selected,Fade)
--checking for any Special Characters
sp_char = {}
for i = 1,#VLF.Buttons do 
local sp_pos = string.find(text,VLF.Buttons[i][1])
	if sp_pos then 
	text = string.sub(text,1,sp_pos-1)..string.rep(" ",VLF.Buttons[i][2])..string.sub(text,sp_pos+#VLF.Buttons[i][1],#text)
	sp_char[#sp_char+1] = {}
	sp_char[#sp_char][1] = font:measure(string.sub(text,1,sp_pos-1))
	sp_char[#sp_char][2] = i
	end
end
if x == VLF_CENTER then 
	x = 240-(font:measure(text)/2)
elseif x == VLF_RIGHT then
	x = 300 - font:measure(text)
end

if not distance then 
	distance = 2
end 

if not radius then 
	radius = 3
end 

if not color then 
	color = pge.gfx.createcolor(pge.gfx.red(VLF.Text_Color),pge.gfx.green(VLF.Text_Color),pge.gfx.blue(VLF.Text_Color),pge.gfx.alpha(VLF.Text_Color))
end 

if Fade then 
	alpha_color = pge.gfx.createcolor(pge.gfx.red(color),pge.gfx.green(color),pge.gfx.blue(color),pge.gfx.alpha(color))
else
	alpha_color = pge.gfx.createcolor(pge.gfx.red(color),pge.gfx.green(color),pge.gfx.blue(color),pge.gfx.alpha(color)*VLF_MAIN_ALPHA)
end 


font:activate()
if shadowcolor then 
	
if shadowcolor == VLF_AUTO_COLOR then 
	VLF_BG_COLOR = pge.texture.pixel(VLF_BG, x,  y)
	shadowcolor = pge.gfx.createcolor(pge.gfx.red(VLF_BG_COLOR)/1.8,pge.gfx.green(VLF_BG_COLOR)/1.8,pge.gfx.blue(VLF_BG_COLOR)/1.8,12)
	VLF_BG_COLOR = nil
end

if not Fade then 
use_shadowcolor = pge.gfx.createcolor(pge.gfx.red(shadowcolor),pge.gfx.green(shadowcolor),pge.gfx.blue(shadowcolor),pge.gfx.alpha(shadowcolor)*VLF_MAIN_ALPHA)
else
use_shadowcolor = shadowcolor
end 
	if pge.gfx.alpha(shadowcolor)  ~= 0 then 
		for doradius = 1,radius do --Draws the shadow 
			for blit_angle = 1, 360, 360/(radius*math.pi) do
			x_shad = x + (math.sin(blit_angle*(math.pi/180))*doradius)
			y_shad = y + (math.cos(blit_angle*(math.pi/180))*doradius)
				if x_shad ~= x and y_shad ~= y then 
				font:print(x_shad+distance, y_shad+distance, use_shadowcolor, text)
				end
			end
		end
	end
end

if selected then 
vlf_text_arrow:activate()
if selected == VLF_ARROW_UP or selected == VLF_ARROW_UP_DOWN then 
	if Fade then 
	pge.texture.draw(vlf_text_arrow,x+font:measure(text)/2 - vlf_text_arrow:width()/2,y - 1 - vlf_text_arrow:height(),nil,nil,nil,nil,nil,nil,6.28/360*180)
	else
	VLF.DrawTexture(vlf_text_arrow,x+font:measure(text)/2 - vlf_text_arrow:width()/2,y - 1 - vlf_text_arrow:height(),nil,nil,nil,nil,nil,nil,6.28/360*180)
	end 
end 
if selected == VLF_ARROW_UP_DOWN or selected == VLF_ARROW_DOWN then 
	if Fade then 
	pge.texture.draw(vlf_text_arrow,x+font:measure(text)/2 - vlf_text_arrow:width()/2,y + 1 + font:height(),nil,nil,nil,nil,nil,nil,nil)
	else
	VLF.DrawTexture(vlf_text_arrow,x+font:measure(text)/2 - vlf_text_arrow:width()/2,y + 1 + font:height(),nil,nil,nil,nil,nil,nil,nil)
	end 
end 

VLF.DrawFocus(x-2, y-1,font:measure(text)+5,font:height()+1)

end
font:activate()

if Fade then 
fade_alpha = 1
else
fade_alpha = VLF_MAIN_ALPHA
end 
soft_color = pge.gfx.createcolor( pge.gfx.red(color), pge.gfx.green(color), pge.gfx.blue(color),(pge.gfx.alpha(color)-140)*fade_alpha)
		font:print(x+0.5, y,soft_color, text)
		font:print(x-0.5, y, soft_color, text)
		font:print(x, y+0.5,soft_color, text)
		font:print(x, y-0.5,soft_color, text)
		font:print(x, y,alpha_color, text)

if #sp_char ~= 0 then 
	for i = 1,#sp_char do 
		VLF.DrawSymbol(math.floor(x+sp_char[i][1]+5),y+3,VLF.Buttons[sp_char[i][2]][1],false,Fade)
	end 
end
end



function VLF.UpdateFocus() 
		if VLF_FOCUS_ALPHA_DECREASE then
		VLF_FOCUS_ALPHA = VLF_FOCUS_ALPHA-VLF_FOCUS_SPEED 
			if VLF_FOCUS_ALPHA<= 10 then 
			VLF_FOCUS_ALPHA_DECREASE = false 
			end  
		else
		VLF_FOCUS_ALPHA = VLF_FOCUS_ALPHA+VLF_FOCUS_SPEED 
			if VLF_FOCUS_ALPHA>= 255 then 
			VLF_FOCUS_ALPHA_DECREASE = true 
			end  
		end
end 

function VLF.DrawFocus(x,y,width,height,alpha)
	if apha then 
		Focus_alpha = 255/alpha
	else
		Focus_alpha = VLF_FOCUS_ALPHA
	end
	if not movex then 
		movex = x
		movey = y 
		movew = width
		moveh = height
	end 
	if not VLF_DISABLE_FOCUS_ANIMATION then 
		if x ~= movex or y ~= movey or width ~= movew or height ~= moveh then --koordinaten ändern sich /sind nicht dieselben wie die angegebenen
			if not focus_moving then --focus bewegt sich nicht die neuen koordianten werden festgelegt 
				VLF_FOCUS_ALPHA = 130
				if VLF_FOCUS_ANIMATION_FRAMES > 5 then 
					VLF_FOCUS_ANIMATION_FRAMES = 5 
				end 
				movetox = x
				movetoy = y
				movetow = width
				movetoh = height
				xstep = (movex-movetox)/(VLF_FOCUS_ANIMATION_FRAMES*2)
				ystep = (movey-movetoy)/(VLF_FOCUS_ANIMATION_FRAMES*2)
				wstep = (movew-movetow)/(VLF_FOCUS_ANIMATION_FRAMES*2)
				hstep = (moveh-movetoh)/(VLF_FOCUS_ANIMATION_FRAMES*2)
				focus_moving = true 
			end 
		end 
	
	if movex == movetox and movey == movetoy and movew == movetow and moveh == movetoh or VLF_MAIN_ALPHA ~= 1 then 
	--ziel erreicht focus animation gestoppt
	focus_moving = false
	end 

	if focus_moving then --bewegung des focus
		movex = movex - xstep
		movey = movey - ystep
		movew = movew - wstep
		moveh = moveh - hstep
	end 
	else
	movex = x 
	movey = y
	movew = width
	moveh = height 
	end 
choice:activate()
VLF.DrawTexture(choice, movex, movey,movew,moveh,0,0,choice:width(),choice:height(),0,VLF_FOCUS_ALPHA)
end 

function VLF.DrawTextBox(name,text,x,y,selected,width,height)
if not width then 
	width = 316
end
if not height then 
	height = 18
end 
if not x or x == VLF_CENTER then 
x = 240-(width/2)
end 

textbox:activate()
VLF.DrawTexture(textbox,x,y,width,height)
if selected then 
VLF.DrawFocus(x+1,y+1,width-2,height-3)
end 
if name then 
VLF.DrawText(x,y-17,VLF.Font,name,2,3,VLF.Text_Color,VLF_AUTO_COLOR)
end
if text then
VLF.DrawText(x+3,y+2,VLF.Font,text,2,3,VLF.Text_Color,VLF_AUTO_COLOR)
end
end 

--[[
function VLF.DrawLateralMenu(table,selected,anim,width,color)
anim = anim or 1
width = width or 160

end
]]

function VLF.DrawCentralMenu(table,selected,font,align,spacing,x,y,object_limit)
font = font or VLF.Font
spacing = spacing or 5
y = y or 136
x = x or 180
CNTM_SCROLL = CNTM_SCROLL or 0

if table ~= oldtable or not oldtable then
use_table = {}
if type(table[1]) == "string" then 
	for i = 1, #table do 
	use_table[i] = {table[i],2,3,VLF.Text_Color,VLF.Shadow_Color}
	end 
else
	for i = 1, #table do 
		if #table[i] == 1 then 
		use_table[i] = {table[i][1],2,3,VLF.Text_Color,VLF.Shadow_Color}
		else
		use_table[i] = table[i]
		end	 
	end 
end 
CNTM_SCROLL = 0 
SET_HIGHLIGHT_BUTTON = 1
oldtable = table
end 

if #table > 9 and not  object_limit then 
	object_limit = 9
end 

if not object_limit or object_limit > #table then 
object_limit = #table
CNTM_SCROLL = 0
end 

	local y_start = y - (font:height()*object_limit+spacing*(object_limit-1))/2
	local step = font:height()+spacing
		local CTM_RETURN = nil
	if selected == VLF_USE_BUTTONS then 
	if SET_HIGHLIGHT_BUTTON then 
		CNTM_CUR_STATE = SET_HIGHLIGHT_BUTTON
		SET_HIGHLIGHT_BUTTON = false
	end 
	if pge.controls.pressed(PGE_CTRL_UP) then 
	if CNTM_CUR_STATE ~= 1 then 
	CNTM_CUR_STATE = CNTM_CUR_STATE - 1
	pge.wav.play(SND_CURSOR)
	end 
	end 

	if pge.controls.pressed(PGE_CTRL_DOWN) then 
	if CNTM_CUR_STATE ~= #table then 
	CNTM_CUR_STATE = CNTM_CUR_STATE + 1
	pge.wav.play(SND_CURSOR)
	end 
	end 
            
	if pge.controls.pressed(PGE_CTRL_CROSS) then 
		CTM_RETURN =  CNTM_CUR_STATE
		pge.wav.play(SND_CURSOR)
		local CTM_RETURN = CNTM_CUR_STATE
	end 
	selected = CNTM_CUR_STATE
	end

	if CNTM_CUR_STATE > object_limit + CNTM_SCROLL then 
	CNTM_SCROLL = CNTM_SCROLL + 1
	end 

	if CNTM_CUR_STATE == CNTM_SCROLL then 
	CNTM_SCROLL = CNTM_SCROLL - 1
	end 
	
	

	if align == 1 or not align then 
		align = VLF_CENTER
	elseif align == 2 then 
		align = x
	elseif align == 3 then 
		align = VLF_RIGHT
	end 
	for Draw = 1,object_limit do 
		if selected then 
			if Draw+CNTM_SCROLL == selected then 
			sel = true 
			else
			sel = false 
			end 
				if object_limit ~= #table then 
					if align ~= x then 
						a_x = 240
					else
						a_x = x 
					end 
					if Draw == 1  and CNTM_SCROLL ~= 0 then 
						vlf_text_arrow:activate()
						VLF.DrawTexture(vlf_text_arrow,a_x - vlf_text_arrow:width()/2,y_start+step*(Draw-1) - 1 - vlf_text_arrow:height(),nil,nil,nil,nil,nil,nil,6.28/360*180)
					end
					if Draw == object_limit  and CNTM_SCROLL ~= #table-object_limit then 
						vlf_text_arrow:activate()
						VLF.DrawTexture(vlf_text_arrow,a_x - vlf_text_arrow:width()/2,y_start+step*(Draw-1) + 1 + font:height(),nil,nil,nil,nil,nil,nil,nil)
					end
				end 
		else
		sel = false
		end 
	VLF.DrawText(align,y_start+step*(Draw-1),font,use_table[Draw+CNTM_SCROLL][1],use_table[Draw+CNTM_SCROLL][2],use_table[Draw+CNTM_SCROLL][3],use_table[Draw+CNTM_SCROLL][4],use_table[Draw+CNTM_SCROLL][5],sel)
	end

return CTM_RETURN
end

--[[
function VLF.DrawXMB(table,x,y,distance,sub_distance,smothness) --PRE PRE ALPHA

if table ~= oldtable then 
		for i = 1,#table do
		table[i].y = 0
		table[i].cur_icon = 1
		end 
	oldtable = table
end 

pressed_icon = nil 
pressed_tab = nil
	
distance = distance or 97
sub_distance = sub_distance or 65
set_x = x or 100
set_y = y or 90
anim_x = anim_x or 0
smothness = smothness or 4
current_icon = current_icon or 1
if pge.controls.held(PGE_CTRL_LEFT) and current_icon ~= 1 and not set_pos then 
	move_right = true	
	pge.wav.play(SND_CURSOR) 
end 
if pge.controls.held(PGE_CTRL_RIGHT) and current_icon ~= #table and not set_pos and not move_right then 
	move_left = true 
	pge.wav.play(SND_CURSOR)
end 
if pge.controls.held(PGE_CTRL_UP) and table[current_icon].cur_icon ~= 1 and not set_pos and not move_right and not move_left then 
	move_down = true	
	pge.wav.play(SND_CURSOR) 
end 
if pge.controls.held(PGE_CTRL_DOWN) and table[current_icon].cur_icon ~= #table[current_icon] and not set_pos and not move_right and not move_left and not move_down then 
	move_up = true 
	pge.wav.play(SND_CURSOR)
end 

if pge.controls.pressed(PGE_CTRL_CROSS) then 
pressed_icon = table[current_icon].cur_icon
pressed_tab = current_icon
pge.wav.play(SND_CURSOR) 
end 

	if move_right then 
		if not set_pos then 
		set_pos = anim_x + distance
		calc_pos = anim_x + distance+smothness
		end
		if anim_x < set_pos then 
			anim_x = anim_x + (calc_pos-anim_x)/VLF_XMB_LAG
		else
			current_icon = current_icon - 1
			anim_x = set_pos
			set_pos = false
			move_right = false
		end 
	end 	
	if move_left then 
			if not set_pos then 
		set_pos = anim_x - distance
		calc_pos = anim_x - distance - smothness
		end
		if anim_x > set_pos then 
			anim_x = anim_x - (anim_x-calc_pos)/VLF_XMB_LAG
		else
			current_icon = current_icon + 1
			anim_x = set_pos
			set_pos = false
			move_left = false 
		end 
	end 	

	if move_down then 
		if not set_pos then 
		set_pos = table[current_icon].y + sub_distance
		calc_pos = table[current_icon].y + sub_distance+smothness
		end
		if table[current_icon].y < set_pos then 
			table[current_icon].y = table[current_icon].y + (calc_pos-table[current_icon].y)/VLF_XMB_LAG
		else
			table[current_icon].cur_icon = table[current_icon].cur_icon - 1
			table[current_icon].y = set_pos
			set_pos = false
			move_down = false
		end 
	end 	
	if move_up then 
			if not set_pos then 
		set_pos = table[current_icon].y - sub_distance
		calc_pos =table[current_icon].y - sub_distance - smothness
		end
		if table[current_icon].y > set_pos then 
			table[current_icon].y = table[current_icon].y - (table[current_icon].y-calc_pos)/VLF_XMB_LAG
		else
			table[current_icon].cur_icon = table[current_icon].cur_icon + 1
			table[current_icon].y = set_pos
			set_pos = false
			move_up= false 
		end 
	end 	

	for main_icons = 1,#table do 
	x_icon = math.floor(anim_x + set_x+((main_icons-1)*distance)+0.5)
	perc_dis = 1-(1/distance*math.abs(x_icon-set_x))
	if perc_dis < 0 then 
		perc_dis = 0 
	end 
	icon_alpha = 190 + perc_dis * 65
	icon_width = table[main_icons].icon:width()--*(0.9+perc_dis*0.1)
	icon_height = table[main_icons].icon:height()--*(0.9+perc_dis*0.1)
	icon_y = set_y-(icon_height/2)-perc_dis*5

		for sub_icons = 1,#table[current_icon] do	
			if main_icons == current_icon then	
			

				if table[current_icon].y + ((sub_icons-1)*sub_distance) < (smothness*-1) then  	
				sub_jmp = 1 + 0.8/sub_icons
				else
				sub_jmp = 1 
				end 
			
			table[main_icons][sub_icons].icon:activate()			
			VLF.DrawTexture(
				table[main_icons][sub_icons].icon,
				x_icon+5,
				icon_y + icon_height + 18 + table[current_icon].y*sub_jmp + ((sub_icons-1)*sub_distance),
				nil,nil,nil,nil,nil,nil,nil,
				255*perc_dis
				)	
			
			VLF.DrawText(
				x_icon+icon_width+5,
				icon_y + icon_height + 20 + table[current_icon].y*sub_jmp + ((sub_icons-1)*sub_distance)+10,
				VLF.Font,table[main_icons][sub_icons].name,
				2,
				3,
				pge.gfx.createcolor(pge.gfx.red(VLF.Text_Color),pge.gfx.green(VLF.Text_Color),pge.gfx.blue(VLF.Text_Color),255*perc_dis),
				pge.gfx.createcolor(pge.gfx.red(VLF.Shadow_Color),pge.gfx.green(VLF.Shadow_Color),pge.gfx.blue(VLF.Shadow_Color),pge.gfx.alpha(VLF.Shadow_Color)*perc_dis)
				)
			end 
		end
	if x_icon == set_x then
	VLF.DrawText(set_x+icon_width/2-VLF.Font_small:measure(table[main_icons].name)/2,
		icon_y+icon_height+1,
		VLF.Font_small,table[main_icons].name,
		2,
		3,
		VLF.Text_Color,
		VLF.Shadow_Color
		)
	end 

	table[main_icons].icon:activate()
	VLF.DrawTexture(table[main_icons].icon,
		x_icon,
		icon_y,
		icon_width,
		icon_height,
		nil,nil,nil,nil,nil,
		icon_alpha
		)
	end
	if pressed_icon then 
	return pressed_icon , pressed_tab
	end
end 
]]

function VLF.DrawScrollBar(text,act,x,y,height)
if not height then 
height = 140
end
if not y_sc then 
	y_sc = 0
	scr_wy = height/(((VLF.Font:height()*#text)+3*(#text-1))/height)
end 
if not y then 
	y = 45
end 
if not x then  
	x = 85
end 

if act == VLF_USE_BUTTONS then 
if pge.controls.held(PGE_CTRL_UP) then 
act = 1
end 

if pge.controls.held(PGE_CTRL_DOWN) then 
act = 0 
end 
end 

y_sc_p = 100/(((VLF.Font:height()*#text)+3*(#text-1))-height)*y_sc
y_scr = y_sc_p/100*(height-scr_wy)
if y_sc_p < 0 then 
	y_sc = old_y_sc
	y_sc_p = 100/(((VLF.Font:height()*#text)+3*(#text-1))-height)*y_sc
	y_scr = y_sc_p/100*(height-scr_wy)
end 
if y_sc_p >= 100 then 
	y_sc = old_y_sc
	y_sc_p = 100/(((VLF.Font:height()*#text)+3*(#text-1))-height)*y_sc
	y_scr = y_sc_p/100*(height-scr_wy)
end 
scr_line_back:activate()
VLF.DrawTexture(scr_line_back,x-1,y,12,height+4)
scr_line:activate()
VLF.DrawTexture(scr_line,x,y+y_scr,5, scr_wy)
for output = 1, #text do 
	if y+((output-1)*(VLF.Font:height()+3))-y_sc > y-5 and y+((output-1)*(VLF.Font:height()+3))-y_sc < y+height-10 then 
	VLF.DrawText(x+15,y+((output-1)*(VLF.Font:height()+3))-y_sc,VLF.Font,text[output],2,2,VLF.Text_Color,VLF.Shadow_Color)
	end 
end

old_y_sc = y_sc

if act == 1 then 
	y_sc = y_sc - 7
elseif act == 0 then
	y_sc = y_sc + 7
end 
end 


function VLF.Draw_Waves(wvy1,wvy2,speed,alpha,move_y)
if not alpha then 
	alpha = VLF_WAVE_ALPHA 
end 
if not positions  then 
positions = {
{move_left = true,x = 0,x_size = 648,y = 0},
{move_left = false ,x = -50,y =0}
}
end

function move_wave_a()
	if positions[1].move_left then 
	positions[1].x_size = positions[1].x_size + (950-positions[1].x_size)/speed
	if positions[1].x_size >= 900 then 
	positions[1].move_left = false
	end 
	else
	positions[1].x_size = positions[1].x_size - (positions[1].x_size-480)/speed
	if positions[1].x_size <=  512 then 
	positions[1].move_left = true
	end 
	end 
end  


function move_wave_b()
		if positions[2].move_left then
		positions[2].x = positions[2].x - (positions[2].x - -500)/(speed*((5-((positions[2].x+300)/100))/2))
			if positions[2].x + 885 <= 485 then 				
				positions[2].move_left = false
			end
		else
		positions[2].x = positions[2].x + (-3 - positions[2].x)/speed
			if positions[2].x >= -5 then 
				positions[2].move_left = true
			end
		end
	end	
--VLF.DrawText(10,30,VLF.Font,(5-((positions[2].x+300)/100))/2,2,2,VLF.Text_Color,VLF.Shadow_Color)
if move_y then 
	local y = math.floor((move_y/920)*(positions[2].x*-1)+0.5)
	positions[1].y = y
	positions[2].y = y
	wy1,wy2 = 0,0
	else
	wy1 = 15
	wy2 = 22
end 

move_wave_a()
move_wave_b()
	wave_a:activate()
	wave_a:draw(positions[1].x, wy1+wvy1+positions[1].y,positions[1].x_size,wave_a:height(),0,0,wave_a:width(),wave_a:height(),0,alpha)
	wave_b_1:activate()	
	wave_b_1:draw(math.floor(positions[2].x+0.5),wy2+wvy2+positions[2].y,wave_b_1:width(),wave_b_1:height(),0,0,wave_b_1:width(),wave_b_1:height(),0,alpha) 	
	wave_b_2:activate()	
	wave_b_2:draw(math.floor(positions[2].x+0.5)+512,wy2+wvy2+positions[2].y,wave_b_2:width(),wave_b_2:height(),0,0,wave_b_2:width(),wave_b_2:height(),0,alpha) 	

end



function VLF.DrawClock(shift,x,y)
shift = shift or 0
test = true
VLF.time = os.date("*t")
	if test then 
	      batterie_shadow_img:activate()
	      batterie_shadow_img:draweasy(449,4,0,170)
	      batterie_img:activate()
		batterie_img:draweasy(449,4)
		batterie_line_img:activate()
		--if System.powerGetBatteryLifePercent() > 25  or 
		if test then 
		batterie_line_img:draweasy(463,4)
		end
		--if System.powerGetBatteryLifePercent() > 50 or test then 
		if test then 
		batterie_line_img:draweasy(458,4)
		end
		--if System.powerGetBatteryLifePercent() > 75 or test then 
		if test then 
		batterie_line_img:draweasy(453,4)
		end
	end
if VLF.time.min < 10 then 
t_m = "0"..VLF.time.min
else
t_m = VLF.time.min
end 
t_h = VLF.time.hour + 2 +shift
if t_h == 24 then 
t_h = 0 
VLF.time.day = VLF.time.day + 1
end
time = VLF.time.day.."/"..VLF.time.month.." "..t_h..":"..t_m
time_x = 445-VLF.Font:measure(time)
if x then
	time_x = x 
end 
if not y then 
y = 5 
end 
VLF.DrawText(time_x,y,VLF.Font,time,3,4,VLF.Text_Color,VLF.Shadow_Color,false,true)
end

function VLF.DrawTitleBar(text,anim,image,Color)
if vlf_frame_active then 
vlf_frame_text = text 
vlf_frame_anim = anim
vlf_frame_image = image
vlf_frame_color = Color
else
if not anim then
		anim = 1
	end 
	if anim == 1 then		
		if top_y <0 then 
		top_y = top_y + 24/3
		end 	
	elseif anim == 2 then 
		if top_y > -24 then 
		top_y = top_y - 24/3
		end 	
	end 
if not Color then 
	if not CURRENT_BG or CURRENT_BG > 12 then 
	Color = VLF.Colors[1]
	else
	Color  = VLF.Colors[CURRENT_BG]
	end 
end 

if top_y > -22 then 
pge.gfx.drawrect(0, top_y,480, 24,Color)

if image then 
	img_w = image:width()
	image:activate()
	image:draweasy(3,top_y+12-image:height()/2)
else
	img_w = -6
end 

VLF.DrawText(10+img_w,top_y+5,VLF.Font,text,0,0,VLF.Text_Color,false,false,true)
else
return false
end 
end
end

function VLF.DrawOptions(options,text1_,text2_)
if not text1_ then
	text1_ = "Enter"
end
if not text2_ then 
	text2_ = "Back"
end
if options == 1 then --X
VLF.DrawSymbol(181,250,VLF_CROSS)
VLF.DrawText(195,250,VLF.Font_small,text1_,2,3,VLF.Text_Color,VLF.Shadow_Color)
end 
if options == 2 then --O
VLF.DrawSymbol(181,250,VLF_CIRCLE)
VLF.DrawText(195,250,VLF.Font_small,text1_,2,3,VLF.Text_Color,VLF.Shadow_Color)
end 
if options == 3 then --XO
VLF.DrawSymbol(181,250,VLF_CROSS)
VLF.DrawText(195,250,VLF.Font_small,text1_,2,3,VLF.Text_Color,VLF.Shadow_Color)
VLF.DrawSymbol(266,250,VLF_CIRCLE)
VLF.DrawText(280,250,VLF.Font_small,text2_,2,3,VLF.Text_Color,VLF.Shadow_Color)
end 
end 

function VLF.FadeObjects(in_out,speed)
Fade_return = false
if not speed then 
	speed = 0.4
end 
if in_out == 1 then 
VLF_MAIN_ALPHA = VLF_MAIN_ALPHA - speed
	if VLF_MAIN_ALPHA  <= 0 then 
	Fade_return = true 
	VLF_MAIN_ALPHA = 0
	end 
elseif in_out == 2 then 
VLF_MAIN_ALPHA = VLF_MAIN_ALPHA + speed
	if VLF_MAIN_ALPHA  >= 1 then 
	Fade_return = true 
	VLF_MAIN_ALPHA = 1
	end 
end 
return Fade_return
end 


function VLF.DrawFrame()
vlf_frame_active = false
VLF.UpdateFocus()
if VLF_BG then 
VLF_BG:activate()
VLF_BG:draw(-3,-3,484,275)
end 
VLF.Draw_Waves(0,0,70)
	if vlf_frame_text then 
		VLF.DrawTitleBar(vlf_frame_text,vlf_frame_anim,vlf_frame_image, vlf_frame_color)
	end 
vlf_frame_text = nil
VLF.DrawClock()
vlf_frame_active = true 
end 

function VLF.SetCustomWave(filepath,key)
key = key or "VLFwv"
wave_table = VLF.GetDataFromfile(filepath,key)	
wave_a = pge.texture.loadmemory(wave_table[1])
wave_b_1 =  pge.texture.loadmemory(wave_table[2])
wave_b_2 =  pge.texture.loadmemory(wave_table[3])
for i = 1, #wave_table do 
wave_table[i] = nil
end
wave_table = nil
end 

function VLF.term()
VLF = nil
VLF_CENTER = nil
VLF_RIGHT = nil
VLF_ARROW_UP = nil
VLF_ARROW_DOWN = nil
VLF_ARROW_UP_DOWN = nil
VLF_USE_BUTTONS = nil
VLF_AUTO_COLOR = nil
OLD_BG = nil
top_y = nil
VLF_XMB_LAG = nil
VLF_MAIN_ALPHA = nil
VLF_FOCUS_SPEED = nil
VLF_FOCUS_ANIMATION_FRAMES = nil
VLF_FOCUS_ALPHA = nil
VLF_FOCUS_ALHPA_DECREASE = nil
SET_HIGHLIGHT_BUTTON = nil
VLF_DISABLE_FOCUS_ANIMATION = nil
VLF_FADE_SPEED_SLOW = nil
VLF_FADE_SPEED_STANDARD = nil
VLF_FADE_SPEED_FAST = nil
VLF_FADE_SPEED_VERY_FAST = nil
VLF_FADE_SPEED_SUPER_FAST = nil
TOP = nil
VLF_CROSS = nil
VLF_CIRCLE = nil
VLF_SQUARE = nil
VLF_TRIANGLE = nil
VLF_SELECT =nil
VLF_START = nil
VLF_RTRIGGER = nil
VLF_LTRIGGER = nil
choice = nil
SND_CURSOR = nil
wave_a = nil
wave_b_1 = nil
wave_b_2 = nil
inst_line = nil
inst_line_back = nil
scr_line_back = nil
scr_line = nil
batterie_img = nil
batterie_shadow_img = nil
batterie_line_img = nil
textbox = nil
vlf_text_arrow = nil
VLF_cross = nil
VLF_circle = nil
VLF_square = nil
VLF_triangle = nil
VLF_select = nil
VLF_start = nil
VLF_rtrigger =  nil
VLF_ltrigger =  nil
VLF_cross_shad = nil
VLF_circle_shad = nil
VLF_square_shad = nil
VLF_triangle_shad = nil
VLF_select_shad = nil
VLF_start_shad = nil
VLF_rtrigger_shad =  nil
VLF_ltrigger_shad =  nil
collectgarbage()
end 

